# Patch created by krokas
# Date: Sat Sep 16 17:27:10 MSD 2006
# Repository: pnet
# Comments:
# 
#### End of Preamble ####

#### Patch data follows ####
Index: engine/jitc.c
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/jitc.c,v
retrieving revision 1.47
diff -c -r1.47 jitc.c
*** engine/jitc.c	4 Sep 2006 10:11:30 -0000	1.47
--- engine/jitc.c	16 Sep 2006 13:26:29 -0000
***************
*** 264,273 ****
  static ILJitType _ILJitSignature_ILStringWCreate = 0;
  
  /*
!  * void *ILJitDelegateGetClosure(ILExecThread *thread, ILObject *delegate, ILType *delType)
   */
  static ILJitType _ILJitSignature_ILJitDelegateGetClosure = 0;
  
  
  /*
   * Define offsetof macro if not present.
--- 264,283 ----
  static ILJitType _ILJitSignature_ILStringWCreate = 0;
  
  /*
!  * void *ILJitDelegateGetClosure(ILObject *delegate, ILType *delType)
   */
  static ILJitType _ILJitSignature_ILJitDelegateGetClosure = 0;
  
+ /*
+  * static void* MarshalObjectToCustom(void *value, ILType *type, ILMethod *method, ILExecThread *thread)
+  */
+ static ILJitType _ILJitSignature_MarshalObjectToCustom = 0;
+ 
+ /*
+  * static void* MarshalCustomToObject(void *value, ILType *type, ILMethod *method, ILExecThread *thread)
+  */
+ static ILJitType _ILJitSignature_MarshalCustomToObject = 0;
+ 
  
  /*
   * Define offsetof macro if not present.
***************
*** 2221,2230 ****
  
  	args[0] = _IL_JIT_TYPE_VPTR;
  	args[1] = _IL_JIT_TYPE_VPTR;
- 	args[2] = _IL_JIT_TYPE_VPTR;
  	returnType = _IL_JIT_TYPE_VPTR;
  	if(!(_ILJitSignature_ILJitDelegateGetClosure =
! 		jit_type_create_signature(IL_JIT_CALLCONV_CDECL, returnType, args, 3, 1)))
  	{
  		return 0;
  	}
--- 2231,2261 ----
  
  	args[0] = _IL_JIT_TYPE_VPTR;
  	args[1] = _IL_JIT_TYPE_VPTR;
  	returnType = _IL_JIT_TYPE_VPTR;
  	if(!(_ILJitSignature_ILJitDelegateGetClosure =
! 		jit_type_create_signature(IL_JIT_CALLCONV_CDECL, returnType, args, 2, 1)))
! 	{
! 		return 0;
! 	}
! 
! 	args[0] = _IL_JIT_TYPE_VPTR;
! 	args[1] = _IL_JIT_TYPE_VPTR;
! 	args[2] = _IL_JIT_TYPE_VPTR;
! 	args[3] = _IL_JIT_TYPE_VPTR;
! 	returnType = _IL_JIT_TYPE_VPTR;
! 	if(!(_ILJitSignature_MarshalObjectToCustom =
! 		jit_type_create_signature(IL_JIT_CALLCONV_CDECL, returnType, args, 4, 1)))
! 	{
! 		return 0;
! 	}
! 
! 	args[0] = _IL_JIT_TYPE_VPTR;
! 	args[1] = _IL_JIT_TYPE_VPTR;
! 	args[2] = _IL_JIT_TYPE_VPTR;
! 	args[3] = _IL_JIT_TYPE_VPTR;
! 	returnType = _IL_JIT_TYPE_VPTR;
! 	if(!(_ILJitSignature_MarshalCustomToObject = 
! 		jit_type_create_signature(IL_JIT_CALLCONV_CDECL, returnType, args, 4, 1)))
  	{
  		return 0;
  	}
Index: engine/jitc.h
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/jitc.h,v
retrieving revision 1.17
diff -c -r1.17 jitc.h
*** engine/jitc.h	4 Sep 2006 10:11:30 -0000	1.17
--- engine/jitc.h	16 Sep 2006 13:26:30 -0000
***************
*** 226,234 ****
  /*
   * Get the closure for a delegate.
   */
! void *ILJitDelegateGetClosure(ILExecThread *thread,
! 							  ILObject *delegate,
! 							  ILType *delType);
  
  
  #endif  /* IL_USE_JIT */
--- 226,233 ----
  /*
   * Get the closure for a delegate.
   */
! void *ILJitDelegateGetClosure(ILObject *delegate,
! 				ILType *delType);
  
  
  #endif  /* IL_USE_JIT */
Index: engine/jitc_call.c
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/jitc_call.c,v
retrieving revision 1.22
diff -c -r1.22 jitc_call.c
*** engine/jitc_call.c	28 Jul 2006 17:41:54 -0000	1.22
--- engine/jitc_call.c	16 Sep 2006 13:26:32 -0000
***************
*** 150,156 ****
  	jit_label_t labelException = jit_label_undefined;
  	jit_label_t label = jit_label_undefined;
  	ILJitValue args[3];
! 
  
  	/* Allocate an array to hold all of the arguments */
  	/* Find the constructor for the array. */
--- 150,156 ----
  	jit_label_t labelException = jit_label_undefined;
  	jit_label_t label = jit_label_undefined;
  	ILJitValue args[3];
! 	ILJitType callSignature = jit_function_get_signature(jitCoder->jitFunction);
  
  	/* Allocate an array to hold all of the arguments */
  	/* Find the constructor for the array. */
***************
*** 169,175 ****
  	args[0] = thread;
  	args[1] = arrayLength;
  	array = jit_insn_call(jitCoder->jitFunction, 0, jitCtor,
! 						  0, args, 2, 0);
  	jit_insn_branch_if_not(jitCoder->jitFunction, array, &labelException);
  	arrayBase = jit_insn_add_relative(jitCoder->jitFunction,
  									  array,
--- 169,175 ----
  	args[0] = thread;
  	args[1] = arrayLength;
  	array = jit_insn_call(jitCoder->jitFunction, 0, jitCtor,
! 						  callSignature, args, 2, 0);
  	jit_insn_branch_if_not(jitCoder->jitFunction, array, &labelException);
  	arrayBase = jit_insn_add_relative(jitCoder->jitFunction,
  									  array,
***************
*** 593,599 ****
  	ILJitValue returnValue;
  	char *methodName = 0;
  	ILInternalInfo fnInfo;
! 
  #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(IL_WITHOUT_TOOLS)
  	if (jitCoder->flags & IL_CODER_FLAG_STATS)
  	{
--- 593,600 ----
  	ILJitValue returnValue;
  	char *methodName = 0;
  	ILInternalInfo fnInfo;
! 	ILJitType signature = jit_function_get_signature(jitFunction);
! 	
  #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(IL_WITHOUT_TOOLS)
  	if (jitCoder->flags & IL_CODER_FLAG_STATS)
  	{
***************
*** 679,689 ****
  	{
  	#ifdef IL_JIT_THREAD_IN_SIGNATURE
  		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, 0,
  									jitParams, argCount + 1, JIT_CALL_TAIL);
  	#else
  		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, 0,
  									jitParams, argCount, JIT_CALL_TAIL);
  	#endif
  		if(returnItem->engineType != ILEngineType_Invalid)
--- 680,690 ----
  	{
  	#ifdef IL_JIT_THREAD_IN_SIGNATURE
  		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, signature,
  									jitParams, argCount + 1, JIT_CALL_TAIL);
  	#else
  		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, signature,
  									jitParams, argCount, JIT_CALL_TAIL);
  	#endif
  		if(returnItem->engineType != ILEngineType_Invalid)
***************
*** 695,711 ****
  		}
  	}
  	else
! 	{		
! 	#ifdef IL_JIT_THREAD_IN_SIGNATURE
! 		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, 0,
! 									jitParams, argCount + 1, 0);
! 	#else
! 		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, 0,
! 									jitParams, argCount, 0);
! 	#endif
! 		if(returnItem && returnItem->engineType != ILEngineType_Invalid)
  		{
  			jitCoder->jitStack[jitCoder->stackTop] =
  					_ILJitValueConvertToStackType(jitCoder->jitFunction,
--- 696,722 ----
  		}
  	}
  	else
! 	{
! #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(_IL_JIT_ENABLE_DEBUG)
! 		ILPInvoke *pinv = ILPInvokeFind(methodInfo);
! 		if(pinv && ((ILJitMethodInfo*)(methodInfo->userData))->fnInfo.func)
! 		{
! 			returnValue = _ILJitInlinePinvoke(jitCoder, methodInfo, jitParams);
! 		}
! 		else 
! #endif
! 		{	
! 		    #ifdef IL_JIT_THREAD_IN_SIGNATURE
! 			returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 										jitFunction, signature,
! 										jitParams, argCount + 1, 0);
! 		    #else
! 			returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 										jitFunction, signature,
! 										jitParams, argCount, 0);
! 		    #endif
! 		}
!     		if(returnItem && returnItem->engineType != ILEngineType_Invalid)
  		{
  			jitCoder->jitStack[jitCoder->stackTop] =
  					_ILJitValueConvertToStackType(jitCoder->jitFunction,
***************
*** 758,763 ****
--- 769,776 ----
  	ILInternalInfo fnInfo;
  	int internalType = _IL_JIT_IMPL_DEFAULT;
  	char *methodName = 0;
+ 	ILJitType signature = jit_function_get_signature(jitFunction);
+ 	
  	
  #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(IL_WITHOUT_TOOLS)
  	if (jitCoder->flags & IL_CODER_FLAG_STATS)
***************
*** 855,866 ****
  	#ifdef IL_JIT_THREAD_IN_SIGNATURE
  		_ILJitFillArguments(jitCoder, &(jitParams[1]), info);
  		// call the constructor with jitParams as input
! 		returnValue = jit_insn_call(jitCoder->jitFunction, 0, jitFunction, 0,
  									jitParams, argCount + 1, 0);
  	#else
  		_ILJitFillArguments(jitCoder, &(jitParams[0]), info);
  		// call the constructor with jitParams as input
! 		returnValue = jit_insn_call(jitCoder->jitFunction, 0, jitFunction, 0,
  									jitParams, argCount, 0);
  	#endif
  		jitCoder->jitStack[jitCoder->stackTop] = returnValue;
--- 868,879 ----
  	#ifdef IL_JIT_THREAD_IN_SIGNATURE
  		_ILJitFillArguments(jitCoder, &(jitParams[1]), info);
  		// call the constructor with jitParams as input
! 		returnValue = jit_insn_call(jitCoder->jitFunction, 0, jitFunction, signature,
  									jitParams, argCount + 1, 0);
  	#else
  		_ILJitFillArguments(jitCoder, &(jitParams[0]), info);
  		// call the constructor with jitParams as input
! 		returnValue = jit_insn_call(jitCoder->jitFunction, 0, jitFunction, signature,
  									jitParams, argCount, 0);
  	#endif
  		jitCoder->jitStack[jitCoder->stackTop] = returnValue;
***************
*** 874,880 ****
  
  		// call the constructor with jitParams as input
  		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, 0,
  									jitParams, argCount + 2, 0);
  
  		jitCoder->jitStack[jitCoder->stackTop] = jitParams[1];
--- 887,893 ----
  
  		// call the constructor with jitParams as input
  		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, signature,
  									jitParams, argCount + 2, 0);
  
  		jitCoder->jitStack[jitCoder->stackTop] = jitParams[1];
***************
*** 885,891 ****
  
  		// call the constructor with jitParams as input
  		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, 0,
  									jitParams, argCount + 1, 0);
  
  		jitCoder->jitStack[jitCoder->stackTop] = jitParams[0];
--- 898,904 ----
  
  		// call the constructor with jitParams as input
  		returnValue = jit_insn_call(jitCoder->jitFunction, methodName,
! 									jitFunction, signature,
  									jitParams, argCount + 1, 0);
  
  		jitCoder->jitStack[jitCoder->stackTop] = jitParams[0];
